#ifndef COMMAND_H
#define COMMAND_H

#include <fcntl.h>
#include <stdbool.h>
#include <afblib/strlist.h>

typedef struct fd_assignment {
   char* path;
   int oflags;
   mode_t mode;
} fd_assignment;

typedef struct command {
   char* cmdname;
   strlist argv;
   int background;
   /* for file descriptors 0 and 1 */
   fd_assignment assignments[2];
} command;

/* convert list of tokens into a command record;
   return true in case of success */
bool scan_command(strlist* tokens, command* cmd);

/* open input and output files, if required, and
   exec to the given command */
void exec_command(command* cmd);

#endif
